import java.awt.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;

public class Citations extends Applet 
 implements Runnable {

 int numCitation=-1;
 int nivCol=255;
 int direction=-1;
 int xStr;           //position d'affichage
 int yStr;
 Vector datas=new Vector();
 Font fonte=new Font("SansSerif",Font.BOLD+Font.ITALIC,20);
 private Thread processus=null;
 int speed=20;

 public void init() {
  setBackground(Color.white);
  setFont(fonte);
 }
 
 public void start() {
  lireFichier();
  numCitation=hasard(datas.size());
  calculPosition();
  if (processus==null) {
   processus=new Thread(this);
   processus.start();
  }
 }

 public void lireFichier() {
  try {
   URL source=new URL(getCodeBase(),"citations.txt");
   BufferedReader br=new BufferedReader(
    new InputStreamReader(source.openStream()));
   String ligne;
   do {
    ligne=br.readLine();
    if (ligne!=null && ligne.length()>0) 
     datas.addElement(ligne);
   } while (ligne!=null);
   br.close();
  } catch (Exception e) {}
 }
 
 public void stop() {
  if (processus!=null) {
   processus.stop();
   processus=null;
  }
 }

 void calculPosition() {
  FontMetrics fm=getFontMetrics(fonte);
  int l=fm.stringWidth((String)datas.elementAt(numCitation));
  xStr=(getSize().width-l)/2;
  int h=fm.getHeight();
  int h2=fm.getAscent();
  yStr=(getSize().height-h)/2+h2;
 }
 
 int hasard(int n) {
  return (int)Math.floor(Math.random()*n);
 }
 
 public void run() {
  while (processus!=null) {
   repaint();
   //modifications du dessin
   nivCol=nivCol+direction;
   if (nivCol>255) {
    nivCol=255;
    direction=-direction;
    numCitation=hasard(datas.size());
    calculPosition();    
   }
   if (nivCol<0) {
    nivCol=0;
    direction=-direction;
   } 
   try {
    processus.sleep(speed);
   } catch (InterruptedException e){}
  }
  processus=null;
 }

 public void paint(Graphics g) {
  if (numCitation>=0) {
   g.setColor(new Color(nivCol,nivCol,nivCol));
   String S=(String)datas.elementAt(numCitation);
   g.drawString(S,xStr,yStr);
  } 
 }
 
 public void update(Graphics g) {
  paint(g);
 }
 
}
 
